# -*- coding: utf-8 -*-
# by einfall, murxer, pclin & Sven_H for DreamOS

from Components.config import config, ConfigSelectionNumber, ConfigInteger, ConfigYesNo, ConfigIP, ConfigSelection, \
    ConfigSubsection, NoSave, ConfigText, ConfigDateTime
from Plugins.Plugin import PluginDescriptor
from os import system as os_system
from enigma import eTimer
import os
import re
import time

from hyperioncontrol import _, hyperionStart, hyperioncontrol_version, send_CMD, readV4l2_Device, getHyperionInfo, getWledIP

config.plugins.hyperioncontrol = ConfigSubsection()
config.plugins.hyperioncontrol.hyperionAutostart = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionAboveAutostart = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionBelowAutostart = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionLeftAutostart = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionRightAutostart = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.extraLamp = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionModeType = ConfigSelection(choices=[("hyperion", "Hyperion Boblight/KodiServer"), ("hyperion-aml", _("Hyperion-internal grabber")), ("hyperion-v4l2", _("Hyperion-external grabber"))], default="hyperion-aml")
config.plugins.hyperioncontrol.hyperionRemoteType = NoSave(ConfigSelection(choices=[("hyperion", _("Hyperion Boblight/KodiServer")), ("hyperion-aml", _("Hyperion-internal grabber")), ("hyperion-v4l2", _("Hyperion-external grabber")), ("hyperion-above", _("Hyperion Above")), ("hyperion-below", _("Hyperion Below")), ("hyperion-left", _("Hyperion Left")), ("hyperion-right", _("Hyperion Right"))], default="hyperion-aml"))

config.plugins.hyperioncontrol.outputWLED = ConfigYesNo(default=False)

config.plugins.hyperioncontrol.timerHyperion = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.timerMode = ConfigSelection(choices=[("always", _("always")), ("live", _("live mode"))], default="hyperion")
# Monday
config.plugins.hyperioncontrol.timerMondayOnOff = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.timerMondayClockOn = ConfigDateTime(default=time.time(), formatstring="%H:%M", increment=86400)
config.plugins.hyperioncontrol.timerMondayClockOff = ConfigDateTime(default=time.time(), formatstring="%H:%M", increment=86400)
# Tuesday
config.plugins.hyperioncontrol.timerTuesdayOnOff = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.timerTuesdayClockOn = ConfigDateTime(default=time.time(), formatstring="%H:%M", increment=86400)
config.plugins.hyperioncontrol.timerTuesdayClockOff = ConfigDateTime(default=time.time(), formatstring="%H:%M", increment=86400)

# v4l2
config.plugins.hyperioncontrol.v4l2CheckOnOff = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.v4l2CheckIP = ConfigIP(default=[192, 168, 178, 24])
config.plugins.hyperioncontrol.v4l2Check = NoSave(ConfigYesNo(default=False))
config.plugins.hyperioncontrol.v4l2frameDecimation = NoSave(ConfigSelectionNumber(0, 100, 1, default=2))
config.plugins.hyperioncontrol.v4l2sizeDecimation = NoSave(ConfigSelectionNumber(0, 100, 1, default=8))
config.plugins.hyperioncontrol.v4l2cropLeft = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.v4l2cropRight = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.v4l2cropTop = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.v4l2cropBottom = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.v4l2redSignalThreshold = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.v4l2greenSignalThreshold = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.v4l2blueSignalThreshold = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))

# xbmc
config.plugins.hyperioncontrol.xbmcVideoChecker = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.xbmcIP = ConfigIP(default=[192, 168, 178, 24])

config.plugins.hyperioncontrol.saturationGain = NoSave(ConfigSelectionNumber(0, 500, 1, default=100))
config.plugins.hyperioncontrol.valueGain = NoSave(ConfigSelectionNumber(0, 500, 1, default=100))
config.plugins.hyperioncontrol.saturationLGain = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.luminanceGain = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.luminanceMinimum = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.gammaRed = NoSave(ConfigSelectionNumber(0, 500, 1, default=250))
config.plugins.hyperioncontrol.gammaGreen = NoSave(ConfigSelectionNumber(0, 500, 1, default=250))
config.plugins.hyperioncontrol.gammaBlue = NoSave(ConfigSelectionNumber(0, 500, 1, default=250))
config.plugins.hyperioncontrol.thresholdRed = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.thresholdGreen = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.thresholdBlue = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.temperatureRed = NoSave(ConfigSelectionNumber(0, 255, 1, default=255))
config.plugins.hyperioncontrol.temperatureGreen = NoSave(ConfigSelectionNumber(0, 255, 1, default=255))
config.plugins.hyperioncontrol.temperatureBlue = NoSave(ConfigSelectionNumber(0, 255, 1, default=255))
config.plugins.hyperioncontrol.redAdjustRed = NoSave(ConfigSelectionNumber(255, 255, 1, default=255))
config.plugins.hyperioncontrol.redAdjustGreen = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.redAdjustBlue = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.greenAdjustRed = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.greenAdjustGreen = NoSave(ConfigSelectionNumber(255, 255, 1, default=255))
config.plugins.hyperioncontrol.greenAdjustBlue = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.blueAdjustRed = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.blueAdjustGreen = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.blueAdjustBlue = NoSave(ConfigSelectionNumber(255, 255, 1, default=255))
config.plugins.hyperioncontrol.whitelevelRed = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.whitelevelGreen = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.whitelevelBlue = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.blacklevelRed = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.blacklevelGreen = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.blacklevelBlue = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.bbdEnable = NoSave(ConfigYesNo(default=True))
config.plugins.hyperioncontrol.bbdThreshold = NoSave(ConfigSelectionNumber(1, 20, 1, default=4))
config.plugins.hyperioncontrol.smoothingupdateFrequency = ConfigSelection(
    choices=[("1", "1 Hz"), ("5", "5 Hz"), ("10", "10 Hz"), ("15", "15 Hz"), ("20", "20 Hz"), ("25", "25 Hz"),
             ("30", "30 Hz")], default="20")
config.plugins.hyperioncontrol.framegrabberSize = NoSave(ConfigSelection(
    choices=[("160,160", "160x160"), ("320,320", "320x320"), ("384,216", "384x216"), ("640,640", "640x640"),
             ("720,576", "720x576"), ("720,720", "720x720"), ("1280,720", "1280x720"), ("1080,1080", "1080x1080"),
             ("1920,1080", "1920x1080")], default="160,160"))
config.plugins.hyperioncontrol.framegrabberFreq = NoSave(ConfigSelectionNumber(5, 30, 5, default=10))
config.plugins.hyperioncontrol.webConfigEnable = NoSave(ConfigYesNo(default=True))
config.plugins.hyperioncontrol.webConfigPort = NoSave(ConfigInteger(default=8099, limits=(1, 65535)))
config.plugins.hyperioncontrol.bootseqStart = NoSave(
    ConfigSelection(choices=[("color", _("Color")), ("effect", _("Effect")), ("off", _("off"))], default="effect"))
config.plugins.hyperioncontrol.bootseqColor = NoSave(ConfigSelection(choices=[("#FFFFFF", "")], default="#FFFFFF"))
config.plugins.hyperioncontrol.bootseqEffect = NoSave(
    ConfigSelection(choices=[("Rainbow swirl fast", "Rainbow swirl fast")], default="Rainbow swirl fast"))
config.plugins.hyperioncontrol.bootseqDuration = NoSave(ConfigSelectionNumber(0, 10000, 500, default=3000))
config.plugins.hyperioncontrol.onIdleAction = ConfigSelection(
    choices=[("color", _("Color")), ("effect", _("Effect")), ("nothing", _("nothing")), ("off", _("Hyperion off")), ("v4l2", _("V4l2"))],
    default="nothing")
config.plugins.hyperioncontrol.onIdleColor = ConfigText("#FFFFFF", False)
config.plugins.hyperioncontrol.onIdleEffect = ConfigText("Rainbow swirl fast", False)
config.plugins.hyperioncontrol.onIdlebackAction = ConfigSelection(
    choices=[("live", _("live mode")), ("color", _("Color")), ("effect", _("Effect")), ("nothing", _("nothing"))],
    default="nothing")
config.plugins.hyperioncontrol.onIdlebackColor = ConfigText("#FFFFFF", False)
config.plugins.hyperioncontrol.onIdlebackEffect = ConfigText("Rainbow swirl fast", False)

config.plugins.hyperioncontrol.deviceType = ConfigSelection(
    choices=[("udpraw", "UDPRaw"), ("sedu", "Sedulight"), ("adalight", "Adalight"),
             ("AdalightApa102", "Adalight-APA102"), ("karate", "Karatelight"), ("atmo", "Atmolight"),
             ("philipshue", "PhilipsHue"), ("philipshueentertainment", "PhilipsHueEntertainment")], default="udpraw")
config.plugins.hyperioncontrol.configName = ConfigText("HyperionConfig", False)
config.plugins.hyperioncontrol.phe_username = ConfigText("username", False)
config.plugins.hyperioncontrol.phe_clientkey = ConfigText("clientkey", False)
config.plugins.hyperioncontrol.phe_lightIds = ConfigText("lightIds", False)
config.plugins.hyperioncontrol.phe_groupId = ConfigText("groupId", False)
config.plugins.hyperioncontrol.phe_switchOffOnBlack = NoSave(ConfigYesNo(default=True))
config.plugins.hyperioncontrol.outputIP = ConfigIP(default=[192, 168, 178, 24])
config.plugins.hyperioncontrol.outputTYPE = ConfigSelection(
    choices=[("/dev/ttyUSB0", "/dev/ttyUSB0"), ("/dev/ttyACM0", "/dev/ttyACM0"), ("/dev/ttyAMA0", "/dev/ttyAMA0"),
             ("/dev/ttyS0", "/dev/ttyS0"), ("/dev/null", "/dev/null"), ], default="/dev/ttyUSB0")
config.plugins.hyperioncontrol.delayafterconnect = ConfigSelectionNumber(0, 20, 1, default=0)
config.plugins.hyperioncontrol.colorOrder = ConfigSelection(
    choices=[("rgb", "RGB"), ("bgr", "BGR"), ("rbg", "RBG"), ("brg", "BRG"), ("grb", "GRB"), ("gbr", "GBR")],
    default="rgb")
config.plugins.hyperioncontrol.baudrate = ConfigSelection(
    choices=[("38400", "38.400"), ("50000", "50.000"), ("57600", "57.600"), ("100000", "100.000"),
             ("115200", "115.200"), ("150000", "150.000"), ("200000", "200.000"), ("250000", "250.000"),
             ("460800", "460.800"), ("500000", "500.000"), ("800000", "800.000"), ("1000000", "1.000.000")],
    default="200000")
config.plugins.hyperioncontrol.protocol = ConfigSelection(choices=[("0", "0"), ("2", "2"), ("3", "3")], default="0")
config.plugins.hyperioncontrol.lastpicpath = ConfigText("/", False)
config.plugins.hyperioncontrol.ledDirection = ConfigSelection(
    choices=[("1", _("clockwise")), ("2", _("counterclockwise"))], default="1")
config.plugins.hyperioncontrol.ledBegin = ConfigSelection(
    choices=[("0", _("none")), ("1", _("bottom middle")), ("2", _("right bottom")), ("3", _("right top")),
             ("4", _("left top")), ("5", _("left bottom"))], default="0")
config.plugins.hyperioncontrol.ledTop = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.ledDown = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.ledRight = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.ledLeft = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.ledBottomGap = ConfigSelectionNumber(0, 100, 1, default=0)
config.plugins.hyperioncontrol.ledCornerTopLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.ledCornerTopRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.ledCornerBottomLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.ledCornerBottomRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hPicDeep = ConfigSelectionNumber(1, 99, 1, default=8)
config.plugins.hyperioncontrol.vPicDeep = ConfigSelectionNumber(1, 99, 1, default=5)
config.plugins.hyperioncontrol.hPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.vPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.PicOverlap = ConfigSelectionNumber(0, 100, 1, default=0)


# creator
config.plugins.hyperioncontrol.creatorHyperionModeType = ConfigSelection(choices=[("hyperion", "Hyperion Boblight/KodiServer"), ("hyperion-aml", _("Hyperion-internal grabber")), ("hyperion-v4l2", _("Hyperion-external grabber")), ("hyperion-above", _("Hyperion Above")), ("hyperion-below", _("Hyperion Below")), ("hyperion-left", _("Hyperion Left")), ("hyperion-right", _("Hyperion Right"))], default="hyperion-aml")
config.plugins.hyperioncontrol.creatorOutputWLED = ConfigYesNo(default=False)

# external grabber setup
config.plugins.hyperioncontrol.externalGrabberHDR = NoSave(ConfigYesNo(default=False))

# WLED Idle actions
config.plugins.hyperioncontrol.hyperionTVIdle = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionAboveIdle = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionBelowIdle = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionLeftIdle = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionRightIdle = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionSyncIdle = ConfigYesNo(default=False)

# WLED Standby actions
config.plugins.hyperioncontrol.hyperionTVStandby = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionAboveStandby = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionBelowStandby = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionLeftStandby = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.hyperionRightStandby = ConfigYesNo(default=False)

# v4l2
config.plugins.hyperioncontrol.creatorV4l2frameDecimation = NoSave(ConfigSelectionNumber(0, 100, 1, default=2))
config.plugins.hyperioncontrol.creatorV4l2sizeDecimation = NoSave(ConfigSelectionNumber(0, 100, 1, default=8))
config.plugins.hyperioncontrol.creatorV4l2cropLeft = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorV4l2cropRight = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorV4l2cropTop = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorV4l2cropBottom = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorV4l2redSignalThreshold = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorV4l2greenSignalThreshold = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorV4l2blueSignalThreshold = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))

# aml
config.plugins.hyperioncontrol.creatorFramegrabberSize = NoSave(ConfigSelection(
    choices=[("160,160", "160x160"), ("320,320", "320x320"), ("384,216", "384x216"), ("640,640", "640x640"),
             ("720,576", "720x576"), ("720,720", "720x720"), ("1280,720", "1280x720"), ("1080,1080", "1080x1080"),
             ("1920,1080", "1920x1080")], default="160,160"))
config.plugins.hyperioncontrol.creatorFramegrabberFreq = NoSave(ConfigSelectionNumber(5, 30, 5, default=10))

# xbmc
config.plugins.hyperioncontrol.creatorXbmcVideoChecker = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorXbmcIP = ConfigIP(default=[192, 168, 178, 24])

# Boblight
config.plugins.hyperioncontrol.creatorBoblightServer = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorBoblightServerPort = ConfigInteger(default=8099, limits=(1, 65535))

config.plugins.hyperioncontrol.creatorSaturationGain = NoSave(ConfigSelectionNumber(0, 500, 1, default=100))
config.plugins.hyperioncontrol.creatorValueGain = NoSave(ConfigSelectionNumber(0, 500, 1, default=100))
config.plugins.hyperioncontrol.creatorSaturationLGain = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.creatorLuminanceGain = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.creatorLuminanceMinimum = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.creatorGammaRed = NoSave(ConfigSelectionNumber(0, 500, 1, default=250))
config.plugins.hyperioncontrol.creatorGammaGreen = NoSave(ConfigSelectionNumber(0, 500, 1, default=250))
config.plugins.hyperioncontrol.creatorGammaBlue = NoSave(ConfigSelectionNumber(0, 500, 1, default=250))
config.plugins.hyperioncontrol.creatorThresholdRed = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorThresholdGreen = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorThresholdBlue = NoSave(ConfigSelectionNumber(0, 100, 1, default=0))
config.plugins.hyperioncontrol.creatorTemperatureRed = NoSave(ConfigSelectionNumber(0, 255, 1, default=255))
config.plugins.hyperioncontrol.creatorTemperatureGreen = NoSave(ConfigSelectionNumber(0, 255, 1, default=255))
config.plugins.hyperioncontrol.creatorTemperatureBlue = NoSave(ConfigSelectionNumber(0, 255, 1, default=255))
config.plugins.hyperioncontrol.creatorRedAdjustRed = NoSave(ConfigSelectionNumber(255, 255, 1, default=255))
config.plugins.hyperioncontrol.creatorRedAdjustGreen = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.creatorRedAdjustBlue = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.creatorGreenAdjustRed = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.creatorGreenAdjustGreen = NoSave(ConfigSelectionNumber(255, 255, 1, default=255))
config.plugins.hyperioncontrol.creatorGreenAdjustBlue = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.creatorBlueAdjustRed = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.creatorBlueAdjustGreen = NoSave(ConfigSelectionNumber(0, 255, 1, default=0))
config.plugins.hyperioncontrol.creatorBlueAdjustBlue = NoSave(ConfigSelectionNumber(255, 255, 1, default=255))
config.plugins.hyperioncontrol.creatorWhitelevelRed = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.creatorWhitelevelGreen = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.creatorWhitelevelBlue = NoSave(ConfigSelectionNumber(0, 100, 1, default=100))
config.plugins.hyperioncontrol.creatorBlacklevelRed = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.creatorBlacklevelGreen = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.creatorBlacklevelBlue = NoSave(ConfigSelectionNumber(0, 50, 1, default=0))
config.plugins.hyperioncontrol.creatorBbdEnable = NoSave(ConfigYesNo(default=True))
config.plugins.hyperioncontrol.creatorBbdThreshold = NoSave(ConfigSelectionNumber(1, 20, 1, default=4))
config.plugins.hyperioncontrol.creatorSmoothingupdateFrequency = NoSave(ConfigSelection(
    choices=[("1", "1 Hz"), ("5", "5 Hz"), ("10", "10 Hz"), ("15", "15 Hz"), ("20", "20 Hz"), ("25", "25 Hz"),
             ("30", "30 Hz")], default="20"))
config.plugins.hyperioncontrol.creatorWebConfigEnable = NoSave(ConfigYesNo(default=True))
config.plugins.hyperioncontrol.creatorWebConfigPort = NoSave(ConfigInteger(default=8099, limits=(1, 65535)))
config.plugins.hyperioncontrol.creatorBootseqStart = NoSave(
    ConfigSelection(choices=[("color", _("Color")), ("effect", _("Effect")), ("off", _("off"))], default="effect"))
config.plugins.hyperioncontrol.creatorBootseqColor = NoSave(ConfigSelection(choices=[("#FFFFFF", "")], default="#FFFFFF"))
config.plugins.hyperioncontrol.creatorBootseqEffect = NoSave(
    ConfigSelection(choices=[("Rainbow swirl fast", "Rainbow swirl fast")], default="Rainbow swirl fast"))
config.plugins.hyperioncontrol.creatorBootseqDuration = NoSave(ConfigSelectionNumber(0, 10000, 500, default=3000))
config.plugins.hyperioncontrol.creatorDeviceType = ConfigSelection(
    choices=[("udpraw", "UDPRaw"), ("sedu", "Sedulight"), ("adalight", "Adalight"),
             ("AdalightApa102", "Adalight-APA102"), ("karate", "Karatelight"), ("atmo", "Atmolight"),
             ("philipshue", "PhilipsHue"), ("philipshueentertainment", "PhilipsHueEntertainment")], default="udpraw")
config.plugins.hyperioncontrol.creatorConfigName = ConfigText("HyperionConfig", False)
config.plugins.hyperioncontrol.creatorPhe_username = ConfigText("username", False)
config.plugins.hyperioncontrol.creatorPhe_clientkey = ConfigText("clientkey", False)
config.plugins.hyperioncontrol.creatorPhe_lightIds = ConfigText("lightIds", False)
config.plugins.hyperioncontrol.creatorPhe_groupId = ConfigText("groupId", False)
config.plugins.hyperioncontrol.creatorPhe_switchOffOnBlack = NoSave(ConfigYesNo(default=True))
config.plugins.hyperioncontrol.creatorOutputIP = ConfigIP(default=[192, 168, 178, 24])
config.plugins.hyperioncontrol.creatorOutputTYPE = ConfigSelection(
    choices=[("/dev/ttyUSB0", "/dev/ttyUSB0"), ("/dev/ttyACM0", "/dev/ttyACM0"), ("/dev/ttyAMA0", "/dev/ttyAMA0"),
             ("/dev/ttyS0", "/dev/ttyS0"), ("/dev/null", "/dev/null"), ], default="/dev/ttyUSB0")
config.plugins.hyperioncontrol.creatorDelayafterconnect = ConfigSelectionNumber(0, 20, 1, default=0)
config.plugins.hyperioncontrol.creatorColorOrder = ConfigSelection(
    choices=[("rgb", "RGB"), ("bgr", "BGR"), ("rbg", "RBG"), ("brg", "BRG"), ("grb", "GRB"), ("gbr", "GBR")],
    default="rgb")
config.plugins.hyperioncontrol.creatorBaudrate = ConfigSelection(
    choices=[("38400", "38.400"), ("50000", "50.000"), ("57600", "57.600"), ("100000", "100.000"),
             ("115200", "115.200"), ("150000", "150.000"), ("200000", "200.000"), ("250000", "250.000"),
             ("460800", "460.800"), ("500000", "500.000"), ("800000", "800.000"), ("1000000", "1.000.000")],
    default="200000")
config.plugins.hyperioncontrol.creatorProtocol = ConfigSelection(choices=[("0", "0"), ("2", "2"), ("3", "3")], default="0")
config.plugins.hyperioncontrol.creatorLastpicpath = ConfigText("/", False)

# LED above
config.plugins.hyperioncontrol.creatorAboveLedDirection = ConfigSelection(
    choices=[("1", _("clockwise")), ("2", _("counterclockwise"))], default="1")
config.plugins.hyperioncontrol.creatorAboveLedBegin = ConfigSelection(
    choices=[("0", _("none")), ("1", _("bottom middle")), ("2", _("right bottom")), ("3", _("right top")),
             ("4", _("left top")), ("5", _("left bottom"))], default="0")
config.plugins.hyperioncontrol.creatorAboveLedTop = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorAboveLedDown = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorAboveLedRight = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorAboveLedLeft = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorAboveLedBottomGap = ConfigSelectionNumber(0, 100, 1, default=0)
config.plugins.hyperioncontrol.creatorAboveLedCornerTopLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorAboveLedCornerTopRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorAboveLedCornerBottomLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorAboveLedCornerBottomRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorAboveHPicDeep = ConfigSelectionNumber(1, 99, 1, default=8)
config.plugins.hyperioncontrol.creatorAboveVPicDeep = ConfigSelectionNumber(1, 99, 1, default=5)
config.plugins.hyperioncontrol.creatorAboveHPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorAboveVPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorAbovePicOverlap = ConfigSelectionNumber(0, 100, 1, default=0)

# LED below
config.plugins.hyperioncontrol.creatorBelowLedDirection = ConfigSelection(
    choices=[("1", _("clockwise")), ("2", _("counterclockwise"))], default="1")
config.plugins.hyperioncontrol.creatorBelowLedBegin = ConfigSelection(
    choices=[("0", _("none")), ("1", _("bottom middle")), ("2", _("right bottom")), ("3", _("right top")),
             ("4", _("left top")), ("5", _("left bottom"))], default="0")
config.plugins.hyperioncontrol.creatorBelowLedTop = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowLedDown = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowLedRight = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowLedLeft = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowLedBottomGap = ConfigSelectionNumber(0, 100, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowLedCornerTopLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorBelowLedCornerTopRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorBelowLedCornerBottomLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorBelowLedCornerBottomRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorBelowHPicDeep = ConfigSelectionNumber(1, 99, 1, default=8)
config.plugins.hyperioncontrol.creatorBelowVPicDeep = ConfigSelectionNumber(1, 99, 1, default=5)
config.plugins.hyperioncontrol.creatorBelowHPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowVPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorBelowPicOverlap = ConfigSelectionNumber(0, 100, 1, default=0)

# LED left
config.plugins.hyperioncontrol.creatorLeftLedDirection = ConfigSelection(
    choices=[("1", _("clockwise")), ("2", _("counterclockwise"))], default="1")
config.plugins.hyperioncontrol.creatorLeftLedBegin = ConfigSelection(
    choices=[("0", _("none")), ("1", _("bottom middle")), ("2", _("right bottom")), ("3", _("right top")),
             ("4", _("left top")), ("5", _("left bottom"))], default="0")
config.plugins.hyperioncontrol.creatorLeftLedTop = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftLedDown = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftLedRight = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftLedLeft = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftLedBottomGap = ConfigSelectionNumber(0, 100, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftLedCornerTopLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorLeftLedCornerTopRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorLeftLedCornerBottomLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorLeftLedCornerBottomRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorLeftHPicDeep = ConfigSelectionNumber(1, 99, 1, default=8)
config.plugins.hyperioncontrol.creatorLeftVPicDeep = ConfigSelectionNumber(1, 99, 1, default=5)
config.plugins.hyperioncontrol.creatorLeftHPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftVPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorLeftPicOverlap = ConfigSelectionNumber(0, 100, 1, default=0)

# LED right
config.plugins.hyperioncontrol.creatorRightLedDirection = ConfigSelection(
    choices=[("1", _("clockwise")), ("2", _("counterclockwise"))], default="1")
config.plugins.hyperioncontrol.creatorRightLedBegin = ConfigSelection(
    choices=[("0", _("none")), ("1", _("bottom middle")), ("2", _("right bottom")), ("3", _("right top")),
             ("4", _("left top")), ("5", _("left bottom"))], default="0")
config.plugins.hyperioncontrol.creatorRightLedTop = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorRightLedDown = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorRightLedRight = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorRightLedLeft = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorRightLedBottomGap = ConfigSelectionNumber(0, 100, 1, default=0)
config.plugins.hyperioncontrol.creatorRightLedCornerTopLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorRightLedCornerTopRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorRightLedCornerBottomLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorRightLedCornerBottomRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorRightHPicDeep = ConfigSelectionNumber(1, 99, 1, default=8)
config.plugins.hyperioncontrol.creatorRightVPicDeep = ConfigSelectionNumber(1, 99, 1, default=5)
config.plugins.hyperioncontrol.creatorRightHPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorRightVPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorRightPicOverlap = ConfigSelectionNumber(0, 100, 1, default=0)


# LED Hyperion and v4l2
config.plugins.hyperioncontrol.creatorDefaultLedDirection = ConfigSelection(
    choices=[("1", _("clockwise")), ("2", _("counterclockwise"))], default="1")
config.plugins.hyperioncontrol.creatorDefaultLedBegin = ConfigSelection(
    choices=[("0", _("none")), ("1", _("bottom middle")), ("2", _("right bottom")), ("3", _("right top")),
             ("4", _("left top")), ("5", _("left bottom"))], default="0")
config.plugins.hyperioncontrol.creatorDefaultLedTop = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultLedDown = ConfigSelectionNumber(0, 300, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultLedRight = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultLedLeft = ConfigSelectionNumber(0, 200, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultLedBottomGap = ConfigSelectionNumber(0, 100, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultLedCornerTopLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorDefaultLedCornerTopRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorDefaultLedCornerBottomLeft = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorDefaultLedCornerBottomRight = ConfigYesNo(default=False)
config.plugins.hyperioncontrol.creatorDefaultHPicDeep = ConfigSelectionNumber(1, 99, 1, default=8)
config.plugins.hyperioncontrol.creatorDefaultVPicDeep = ConfigSelectionNumber(1, 99, 1, default=5)
config.plugins.hyperioncontrol.creatorDefaultHPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultVPicDist = ConfigSelectionNumber(0, 50, 1, default=0)
config.plugins.hyperioncontrol.creatorDefaultPicOverlap = ConfigSelectionNumber(0, 100, 1, default=0)


def onLeaveStandby():
    print "[HyperionControl] comes back from standby (idle)"
    v4l2.leaveIdle()

    if config.plugins.hyperioncontrol.onIdleAction.value == "v4l2" and not config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion-v4l2":
        value = getHyperionInfo(mode="hyperion-v4l2")
        if value[0]:
            os.system("systemctl stop hyperion-v4l2")

        if config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion-aml":
            os.system("systemctl restart hyperion && systemctl restart hyperionaml")
            os.system("/root/.hyperion/backfromidle.sh")
        elif config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion":
            os.system("systemctl restart hyperion")
            os.system("/root/.hyperion/backfromidle.sh")
    elif config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion-aml":
        os.system("systemctl start hyperion && systemctl start hyperionaml")
    elif config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion-v4l2":
        value = getHyperionInfo(mode="hyperion-v4l2")
        if not value[0]:
            os.system("systemctl restart hyperion-v4l2")
    elif config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion":
        os.system("systemctl restart hyperion")
    if config.plugins.hyperioncontrol.hyperionAboveAutostart.value:
        os.system("systemctl restart hyperion-above")
    if config.plugins.hyperioncontrol.hyperionBelowAutostart.value:
        os.system("systemctl restart hyperion-below")
    if config.plugins.hyperioncontrol.hyperionLeftAutostart.value:
        os.system("systemctl restart hyperion-left")
    if config.plugins.hyperioncontrol.hyperionRightAutostart.value:
        os.system("systemctl restart hyperion-right")

#    send_CMD("-c 'black'")

    # set mode to live-mode on come back from Standby (Idle)
    if config.plugins.hyperioncontrol.onIdlebackAction.value == "color":
        cmd = "-c '%s'" % config.plugins.hyperioncontrol.onIdlebackColor.value
        send_CMD(cmd)
    elif config.plugins.hyperioncontrol.onIdlebackAction.value == "effect":
        cmd = "--effect '%s'" % config.plugins.hyperioncontrol.onIdlebackEffect.value
        send_CMD(cmd)
    elif config.plugins.hyperioncontrol.onIdlebackAction.value == "live":
        send_CMD('--clearall')


def onStandby(configElement):
    print "[HyperionControl] go to standby (idle)..."
    from Screens.Standby import inStandby
    inStandby.onClose.append(onLeaveStandby)
    v4l2.onIdle()
    # set mode on standby (idle)
    if config.plugins.hyperioncontrol.onIdleAction.value == "color":
        print "[HyperionControl] go to standby (idle) color"
        cmd = "-c '%s'" % config.plugins.hyperioncontrol.onIdleColor.value
        send_CMD(cmd)
    elif config.plugins.hyperioncontrol.onIdleAction.value == "effect":
        print "[HyperionControl] go to standby (idle) effect"
        cmd = "--effect '%s'" % config.plugins.hyperioncontrol.onIdleEffect.value
        send_CMD(cmd)
    elif config.plugins.hyperioncontrol.onIdleAction.value == "off":
         print "[HyperionControl] go to standby (idle) off"
         cmd = "systemctl stop hyperionaml"
         os.system(cmd)
         cmd = "systemctl stop hyperion-v4l2"
         os.system(cmd)
         cmd = "systemctl stop hyperion"
         os.system(cmd)
         cmd = "systemctl stop hyperion-above"
         os.system(cmd)
         cmd = "systemctl stop hyperion-below"
         os.system(cmd)         
         cmd = "systemctl stop hyperion-left"
         os.system(cmd)
         cmd = "systemctl stop hyperion-right"
         os.system(cmd)
         if config.plugins.hyperioncontrol.creatorOutputWLED.value:
             print "[HyperionControl] go to standby (idle) WLED on"
             if config.plugins.hyperioncontrol.extraLamp.value:
                 print "[HyperionControl] go to standby (idle) extralamp on"
                 
                 if config.plugins.hyperioncontrol.hyperionAboveAutostart.value:
                     ip = getWledIP("/etc/hyperion/hyperion-above.config.json")
                     if config.plugins.hyperioncontrol.hyperionAboveIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&CY=0&RD=0&RN=0&SN=0&T=0\"" % ip)
                     elif config.plugins.hyperioncontrol.hyperionSyncIdle.value and not config.plugins.hyperioncontrol.hyperionAboveIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&CY=0&RD=0&SN=0&RN=1\"" % ip)
                     else:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&RD=0&RN=0&SN=0&CY=1\"" % ip)
                     print "[HyperionControl] %s" % ip
                     
                 if config.plugins.hyperioncontrol.hyperionBelowAutostart.value:
                     ip = getWledIP("/etc/hyperion/hyperion-below.config.json")
                     if config.plugins.hyperioncontrol.hyperionBelowIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&CY=0&RD=0&RN=0&SN=0&T=0\"" % ip)
                     elif config.plugins.hyperioncontrol.hyperionSyncIdle.value and not config.plugins.hyperioncontrol.hyperionBelowIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&CY=0&RD=0&SN=0&RN=1\"" % ip)
                     else:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&RD=0&RN=0&SN=0&CY=1\"" % ip)
                     print "[HyperionControl] %s" % ip
                     
                 if config.plugins.hyperioncontrol.hyperionLeftAutostart.value:
                     ip = getWledIP("/etc/hyperion/hyperion-left.config.json")
                     if config.plugins.hyperioncontrol.hyperionLeftIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&CY=0&RD=0&RN=0&SN=0&T=0\"" % ip)
                     elif config.plugins.hyperioncontrol.hyperionSyncIdle.value and not config.plugins.hyperioncontrol.hyperionLeftIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&CY=0&RD=0&SN=0&RN=1\"" % ip)
                     else:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&RD=0&RN=0&SN=0&CY=1\"" % ip)
                     print "[HyperionControl] %s" % ip
                     
                 if config.plugins.hyperioncontrol.hyperionRightAutostart.value:
                     ip = getWledIP("/etc/hyperion/hyperion-right.config.json")
                     if config.plugins.hyperioncontrol.hyperionRightIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&CY=0&RD=0&RN=0&SN=0&T=0\"" % ip)
                     elif config.plugins.hyperioncontrol.hyperionSyncIdle.value and not config.plugins.hyperioncontrol.hyperionRightIdle.value:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&CY=0&RD=0&SN=0&RN=1\"" % ip)
                     else:
                         os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&RD=0&RN=0&SN=0&CY=1\"" % ip)
                     print "[HyperionControl] %s" % ip
                     
             if config.plugins.hyperioncontrol.hyperionAutostart.value:
                 ip = getWledIP("/etc/hyperion/hyperion.config.json")
                 if config.plugins.hyperioncontrol.hyperionTVIdle.value:
                     ip = getWledIP("/etc/hyperion/hyperion.config.json")
                     os_system("/usr/bin/curl -X SET \"http://%s/win&CY=0&RD=0&RN=&SN=0&T=0\"" % ip)
                 elif config.plugins.hyperioncontrol.hyperionSyncIdle.value and not config.plugins.hyperioncontrol.hyperionTVIdle.value:
                     os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&RN=0&SN=1&CY=1\"" % ip)
                 else:
                     os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&RN=0&SN=0&CY=1\"" % ip)
                 print "[HyperionControl] %s" % ip
         
         else:
             print "[HyperionControl] go to standby (idle) WLED off"            
    elif config.plugins.hyperioncontrol.onIdleAction.value == "v4l2":
        value = getHyperionInfo(mode="hyperion")
        if value[0]:
            cmd = "systemctl stop hyperion"
            os.system(cmd)
        value = getHyperionInfo(mode="hyperion-aml")
        if value[0]:
            cmd = "systemctl stop hyperionaml"
            os.system(cmd)
        value = getHyperionInfo(mode="hyperion-v4l2")
        if not value[0]:
            os.system("systemctl restart hyperion-v4l2")
    else:
        send_CMD("-c 'black'")


class CheckV4l2:
    def __init__(self):
        self.myTimer = eTimer()
        self.myTimer_conn = self.myTimer.timeout.connect(self.checkV4l2)
        self.idleMode = False
        config.plugins.hyperioncontrol.v4l2Check.value = False

    def leaveIdle(self):
        config.plugins.hyperioncontrol.v4l2Check.value = False
        self.idleMode = False

    def onIdle(self):
        self.idleMode = True

    def checkV4l2(self):
        if config.plugins.hyperioncontrol.v4l2CheckOnOff.value:
            if config.plugins.hyperioncontrol.onIdleAction.value == "v4l2" and readV4l2_Device():
                try:
                    ip = '%d.%d.%d.%d' % tuple(config.plugins.hyperioncontrol.v4l2CheckIP.value)
                    read_proc = os.popen("ping -c 1 -w 2 %s" % ip)
                    proc_data = read_proc.read()
                    read_proc.close()
                    is_standby = True if re.findall("(100% packet loss)", proc_data, re.S) else False
                    if not is_standby and not config.plugins.hyperioncontrol.v4l2Check.value and self.idleMode:
                        value = getHyperionInfo(mode="hyperion")
                        if value[0]:
                            cmd = "systemctl stop hyperion"
                            os.system(cmd)
                        value = getHyperionInfo(mode="hyperion-aml")
                        if value[0]:
                            cmd = "systemctl stop hyperionaml"
                            os.system(cmd)
                        value = getHyperionInfo(mode="hyperion-v4l2")
                        if not value[0]:
                            os.system("systemctl restart hyperion-v4l2")
                        config.plugins.hyperioncontrol.v4l2Check.value = True
                        send_CMD('--clearall')
                    elif is_standby and config.plugins.hyperioncontrol.v4l2Check.value and self.idleMode:
                        config.plugins.hyperioncontrol.v4l2Check.value = False
                        if config.plugins.hyperioncontrol.onIdleAction.value == "color":
                            cmd = "-c '%s'" % config.plugins.hyperioncontrol.onIdleColor.value
                            send_CMD(cmd)
                        elif config.plugins.hyperioncontrol.onIdleAction.value == "effect":
                            cmd = "--effect '%s'" % config.plugins.hyperioncontrol.onIdleEffect.value
                            send_CMD(cmd)
                        else:
                            send_CMD("-c 'black'")
                except:
                    print "[HyperionControl] check device error..."
        self.start()

    def start(self):
        self.myTimer.start(2000)


def sessionstart(reason, **kwargs):
    v4l2.start()
    if kwargs.has_key("session") and reason == 0:
        print "[HyperionControl] sessionstart"
        config.misc.standbyCounter.addNotifier(onStandby, initial_call=False)


v4l2 = CheckV4l2()


def autostart(reason, **kwargs):
    if reason == 0:
        print "[HyperionControl] start"
        if config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion-aml":
            value = getHyperionInfo(mode="hyperion-aml")
            if value[1] and not value[0]:
                os.system("systemctl restart hyperion && systemctl restart hyperionaml")
        elif config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion":
            value = getHyperionInfo(mode="hyperion")
            if value[1] and not value[0]:
                os.system("systemctl restart hyperion")
        elif config.plugins.hyperioncontrol.hyperionModeType.value == "hyperion-v4l2":
            value = getHyperionInfo(mode="hyperion-v4l2")
            if value[1] and not value[0]:
                os.system("systemctl restart hyperion-v4l2")
        if config.plugins.hyperioncontrol.outputWLED.value:
            config_list = []
            if config.plugins.hyperioncontrol.hyperionTVStandby.value:
                config_list.append("/etc/hyperion/hyperion.config.json")
            if config.plugins.hyperioncontrol.extraLamp.value:
                if config.plugins.hyperioncontrol.hyperionAboveStandby.value:
                    config_list.append("/etc/hyperion/hyperion-above.config.json")
                if config.plugins.hyperioncontrol.hyperionBelowStandby.value:
                    config_list.append("/etc/hyperion/hyperion-below.config.json")
                if config.plugins.hyperioncontrol.hyperionLeftStandby.value:
                    config_list.append("/etc/hyperion/hyperion-left.config.json")
                if config.plugins.hyperioncontrol.hyperionRightStandby.value:
                    config_list.append("/etc/hyperion/hyperion-right.config.json")
            if config_list:
                for config_file_path in config_list:
                    ip = getWledIP(config_file_path)
                    if ip:
                        os_system("/usr/bin/curl -X SET \"http://%s/win&T=1&CY=1&RD=1\"" % ip)

    if reason == 1:
        print "[HyperionControl] shutdown"
        # stop hyperion service on shutdown (led's off)
        os_system("systemctl -q is-active hyperionaml  && systemctl stop hyperionaml")
        os_system("systemctl -q is-active hyperion  && systemctl stop hyperion")
        os_system("systemctl -q is-active hyperion-v4l2  && systemctl stop hyperion-v4l2")
        if config.plugins.hyperioncontrol.creatorOutputWLED.value:
            config_list = []
            if config.plugins.hyperioncontrol.hyperionTVStandby.value:
                config_list.append("/etc/hyperion/hyperion.config.json")
            if config.plugins.hyperioncontrol.extraLamp.value:
                if config.plugins.hyperioncontrol.hyperionAboveStandby.value:
                    config_list.append("/etc/hyperion/hyperion-above.config.json")
                if config.plugins.hyperioncontrol.hyperionBelowStandby.value:
                    config_list.append("/etc/hyperion/hyperion-below.config.json")
                if config.plugins.hyperioncontrol.hyperionLeftStandby.value:
                    config_list.append("/etc/hyperion/hyperion-left.config.json")
                if config.plugins.hyperioncontrol.hyperionRightStandby.value:
                    config_list.append("/etc/hyperion/hyperion-right.config.json")
            if config_list:
                for config_file_path in config_list:
                    ip = getWledIP(config_file_path)
                    if ip:
                        os_system("/usr/bin/curl -X SET \"http://%s/win&RN=0&FX=0&T=0\"" % ip)
                        print "[HyperionControl] %s" % ip


def main(session, **kwargs):
    session.open(hyperionStart)


def Plugins(path, **kwargs):
    name = _("Hyperion Control")
    description = _("Control Your LEDs (v%s)") % hyperioncontrol_version
    descriptors = []
    descriptors.append(PluginDescriptor(name=name, where=PluginDescriptor.WHERE_SESSIONSTART, fnc=sessionstart))
    descriptors.append(PluginDescriptor(name=name, where=PluginDescriptor.WHERE_AUTOSTART, fnc=autostart))
    descriptors.append(PluginDescriptor(name=name, description=description, where=PluginDescriptor.WHERE_PLUGINMENU,
                                        icon="hyperioncontrol.png", fnc=main))
    descriptors.append(PluginDescriptor(name=name, where=PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main))
    return descriptors
